/*
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package com.inteligr8.alfresco.acs;

import com.inteligr8.alfresco.acs.model.RequestQuery;
import com.inteligr8.alfresco.acs.model.RequestQuery.LanguageEnum;
import com.inteligr8.alfresco.acs.model.ResultNode;
import com.inteligr8.alfresco.acs.model.ResultSetPaging;
import com.inteligr8.alfresco.acs.model.SearchRequest;

public abstract class UploadIT extends ConditionalIT {
	
	public abstract AcsPublicRestApi getApi();
	
	public String getSharedFolder() {
		RequestQuery query = new RequestQuery();
		query.setLanguage(LanguageEnum.AFTS);
		query.setQuery("=@cm:name:'Shared'");
		
		SearchRequest searchRequest = new SearchRequest();
		searchRequest.setQuery(query);
		
		ResultSetPaging paging = this.getApi().getSearchApi().search(searchRequest);
		ResultNode folderNode = paging.getList().getEntries().iterator().next().getEntry();
		return folderNode.getId();
	}
	
}
